jQuery(function ($) {
  if (window.CodeMirror) {
    $(".gust-cm").each(function (_idx, el) {
      CodeMirror.fromTextArea(el, {
        mode: "application/json",
        lineNumbers: true,
        lineWrapping: true,
        indentWithTabs: false,
        tabSize: 2,
        theme: "darcula",
        lint: true,
        gutters: ["CodeMirror-lint-markers"],
      });
    });
  }

  var rebuildState = {
    loading: false,
  };
  const setRebuildLoading = (loading) => {
    var btn = $("#gust-rebuild-css");
    if (loading) {
      rebuildState.loading = true;
      btn.text("Building...");
    } else {
      rebuildState.loading = false;
      btn.text("Rebuild CSS");
    }
  };

  const saveCss = (css) => {
    $.ajax({
      type: "post",
      url: window.Gust.adminUrl,
      data: {
        action: "gust_save_css",
        nonce: window.Gust.nonce,
        css,
      },
    })
      .then(() => {
        setRebuildLoading(false);
      })
      .catch((e) => {
        console.log(e);
        setRebuildLoading(false);
        alert("There was an error rebuilding your CSS file");
      });
  };

  $("#gust-rebuild-css").click(function (e) {
    e.preventDefault();
    if (rebuildState.loading) return;
    setRebuildLoading(true);
    window.GustWorker.compile(window.Gust.config, window.Gust.safelist, true)
      .then((css) => {
        saveCss(css);
      })
      .catch((e) => {
        console.log(e);
        setRebuildLoading(false);
        alert("There was an error rebuilding your CSS file");
      });
  });
});
